//
//  ViewController.swift
//  CustomPopView-Swift
//
//  Created by gongwenkai on 16/6/21.
//  Copyright © 2016年 gongwenkai. All rights reserved.
//

import UIKit
import SnapKit

class ViewController: UIViewController,UITableViewDataSource,UITableViewDelegate,PopViewDelegate {
    @IBOutlet var nav: UINavigationBar!
    let BINScreenW = UIScreen.mainScreen().bounds.size.width

    //右点击
    @IBAction func clickRight(sender: AnyObject) {
        let popView:CustomPopView = popViewWith(PopViewPosition.right)
        popView.showInRect()
        //设置约束
        setConstraints(popView,position: .right)

    }
    
    //左点击
    @IBAction func clickLeft(sender: AnyObject) {
        let popView:CustomPopView = popViewWith(PopViewPosition.left)
        popView.showInRect()
        //设置约束
        setConstraints(popView,position: .left)

    }
    
    //中点击
    @IBAction func clickBtn(sender: AnyObject) {
        let popView:CustomPopView = popViewWith(PopViewPosition.center)
        popView.showInRect()
        //设置约束
        setConstraints(popView,position: .center)
    }
    
    /*
     **约束条件
     */
    func setConstraints(popView:CustomPopView,position:PopViewPosition)  {

        popView.meunImageView!.snp_makeConstraints { (make) in
            
            //根据position设置菜单view的位置
            switch position{
            case .left:
                make.left.equalTo(5)
            case .right:
                 make.right.equalTo(popView.snp_right).offset(-5)
            case .center:
                make.centerX.equalTo(0)

            }
            make.width.equalTo(popView.snp_width).multipliedBy(0.5)
            make.height.equalTo(popView.snp_height).multipliedBy(0.5)
            make.top.equalTo(nav.snp_bottom).offset(-10)
            
        }
        popView.contentView?.snp_makeConstraints(closure: { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.bottom.equalTo(popView.meunImageView!).offset(-10)
            make.top.equalTo(popView.meunImageView!).offset(15)
        })
    }
    
    /*
     **初始化popView
     */
    func popViewWith(arrowPosition:PopViewPosition) -> CustomPopView {
        let tableView = UITableView.init(frame: CGRectZero, style: .Plain)
//        tableView.backgroundColor = UIColor.greenColor()
        tableView.tag = arrowPosition.rawValue
        tableView.delegate = self
        tableView.dataSource = self
        tableView.registerClass(UITableViewCell.self, forCellReuseIdentifier: "cell")
        let  popView = CustomPopView.init(frame: CGRectZero)
        popView.menuWithContentView(tableView)
        popView.delegate = self
        popView.arrowPosition = arrowPosition
        return popView
        
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
//        nav.translatesAutoresizingMaskIntoConstraints = true
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    //tableviewdatasource 必选方法
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 2
    }
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell{
        
        let cell = tableView .dequeueReusableCellWithIdentifier("cell", forIndexPath: indexPath) as UITableViewCell
        cell.textLabel!.text="1234544444567thf"
        return cell;
    }
}


